//+------------------------------------------------------------------+  
//|                                                       dJMA.mq4   | 
//+------------------------------------------------------------------+  
#property copyright "Copyright  2008"
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Red

extern int Length = 10;   
extern int Phase  = 0;

extern double buy_frac = 0.5; //vary between 0.1 to 1.0
extern double sell_frac = 0.4; //vary between 0.1 to 1.0

int Shift  = 0;   
int Input_Price_Customs = 0;

double ind_buffer1[];
double ind_buffer2[];

double result = 0, currentPrice = 0,currentJMA = 0, previousJMA = 0, currentATR = 0, previousATR = 0;

#include <JJMASeries.mqh> 
#include <PriceSeries.mqh>


int init() 
   {  
   IndicatorBuffers(2);

   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);

   SetIndexBuffer(0, ind_buffer1);
   SetIndexBuffer(1, ind_buffer2);

   SetIndexEmptyValue(0,0.0);    
   SetIndexEmptyValue(1,0.0);       

   SetIndexShift (0, Shift);
   SetIndexShift (1, Shift);
   IndicatorShortName("dJMA "+Length);

   JJMASeriesAlert (0,"Length",Length);
   JJMASeriesAlert (1,"Phase", Phase);
   PriceSeriesAlert(Input_Price_Customs);
   if (JJMASeriesResize(2)!=2)return(-1);
   return(0); 
   } 


int start() 
   { 
   double temp;
   int i;
   if (Bars-1 < 2*Length)return(0);
   int reset,MaxBar,counted_bars=IndicatorCounted();

   if (counted_bars<0)return(-1);

   if (counted_bars>0) counted_bars--;

   int limit=Bars-counted_bars-1; 
   MaxBar=Bars-1; 

  for(int bar=limit;bar>=0;bar--)
  {
      //get current JMA
      currentPrice = PriceSeries(Input_Price_Customs, bar);//-PriceSeries(Input_Price_Customs, bar+1);
      result = JJMASeries(0,0,MaxBar,limit,Phase,Length,currentPrice,bar,reset);
      if(reset!=0)return(-1);
      previousJMA = currentJMA;
      currentJMA = result;
     
      //calculate ATR
       double high=High[bar];
       double low =Low[bar];
      if(bar==Bars-1)
      {
       currentPrice=high-low;
       }
      else
        {
         double prevclose = Close[bar+1];
         currentPrice = MathMax(high,prevclose)-MathMin(low,prevclose);
        }
        
      result = JJMASeries(0,0,MaxBar,limit,Phase,Length,currentPrice,bar,reset);
      if(reset!=0)return(-1);
      previousATR = currentATR;
      currentATR = result;
           
     //update signals
     if(currentJMA > (previousJMA + (previousATR*Point/buy_frac))) ind_buffer1[bar]=1.0;//currentJMA-previousJMA;
     
     if(currentJMA < (previousJMA - (previousATR*Point/sell_frac))) ind_buffer2[bar]=-1.0;//currentJMA-previousJMA;
     

  }// end for loop
     

   return(0); 
   } 


